unit Unit1;  // emboss bumpmapper - by: gordy 5/10/2001
             // example for fastlib
interface    // 2001 G-Soft http://gfody.com

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Math, FastDIB, FastFX, FastSize, FastFiles,
  FConvert, FastBlend, IniFiles;

type
  TBumpForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ImageThumb: TImage;
    Label1: TLabel;
    Label2: TLabel;
    FormatBox: TComboBox;
    Label3: TLabel;
    BlendBox: TComboBox;
    Button1: TButton;
    OpenDialog: TOpenDialog;
    BumpThumb: TImage;
    Label4: TLabel;
    Button2: TButton;
    Label5: TLabel;
    bumpLightbar: TScrollBar;
    Label6: TLabel;
    bumpContrastbar: TScrollBar;
    Label7: TLabel;
    bumpNoisebar: TScrollBar;
    LightThumb: TImage;
    Label8: TLabel;
    Button3: TButton;
    ScrollBox1: TScrollBox;
    Label9: TLabel;
    Lightbar: TScrollBar;
    HighlightPage: TPageControl;
    RedSheet: TTabSheet;
    GreenSheet: TTabSheet;
    BlueSheet: TTabSheet;
    HighlightsBox: TCheckBox;
    RThumb: TImage;
    GThumb: TImage;
    BThumb: TImage;
    Label10: TLabel;
    RSpecbar: TScrollBar;
    Label11: TLabel;
    RFocusbar: TScrollBar;
    Label12: TLabel;
    RDiffusebar: TScrollBar;
    Label13: TLabel;
    GSpecbar: TScrollBar;
    Label14: TLabel;
    GFocusbar: TScrollBar;
    Label15: TLabel;
    GDiffusebar: TScrollBar;
    Label16: TLabel;
    BSpecbar: TScrollBar;
    Label17: TLabel;
    BFocusbar: TScrollBar;
    Label18: TLabel;
    BDiffusebar: TScrollBar;
    AllSheet: TTabSheet;
    Label19: TLabel;
    ASpecbar: TScrollBar;
    Label20: TLabel;
    AFocusbar: TScrollBar;
    Label21: TLabel;
    ADiffusebar: TScrollBar;
    Label22: TLabel;
    lightNoisebar: TScrollBar;
    lightNoisebox: TCheckBox;
    Label23: TLabel;
    lightRotatebar: TScrollBar;
    lightRotatebox: TCheckBox;
    Light8Box: TCheckBox;
    FpsTimer: TTimer;
    FPSBox: TCheckBox;
    Label24: TLabel;
    PresetsBox: TComboBox;
    AutoLightbox: TCheckBox;
    Button4: TButton;
    procedure MakeLightMap(Size:Integer);
    procedure LoadImage(FileName:string; Base,Live:TFastDIB);
    procedure LoadBumpmap(FileName:string);
    procedure EmbossBumpmap;
    procedure SetThumbnail(Image:TImage; Bmp:TFastDIB);
    procedure LutThumb(Lut:TLut;Image:TImage;Color:TFColor);
    procedure LutThumb8(Lut:TLut);
    procedure UpdateLightmap;
    procedure Render(x,y:Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormatBoxChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bumpLightbarChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RSpecbarChange(Sender: TObject);
    procedure GSpecbarChange(Sender: TObject);
    procedure BSpecbarChange(Sender: TObject);
    procedure ASpecbarChange(Sender: TObject);
    procedure LightbarChange(Sender: TObject);
    procedure HighlightsBoxClick(Sender: TObject);
    procedure AFocusbarChange(Sender: TObject);
    procedure ADiffusebarChange(Sender: TObject);
    procedure lightNoisebarChange(Sender: TObject);
    procedure lightNoiseboxClick(Sender: TObject);
    procedure lightRotatebarChange(Sender: TObject);
    procedure lightRotateboxClick(Sender: TObject);
    procedure BlendBoxChange(Sender: TObject);
    procedure Light8BoxClick(Sender: TObject);
    procedure FpsTimerTimer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure PresetsBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Image24,Image: TFastDIB;
    Lightmap24,BaseLightmap,Lightmap,LightCopy: TFastDIB;
    BaseBumpmap,Bumpmap: TFastDIB;
    Frame: TFastDIB;

    LightRLut,LightGLut,LightBLut: TLut;
    Fps: Integer;
  end;

var
  BumpForm: TBumpForm;
  LightAll: Boolean = False;
  UseLight24: Boolean = False;
  LoadingSet: Boolean = False;
  Angle: Double = 0.0;
  Frames: Integer = 0;
  ImageFile,BumpFile,LightFile: string;

implementation

uses Unit2;

{$R *.DFM}

function SpecularLut(Specular,Diffuse,Focus:Double):TLut;
var
  i,r: Integer;
  x,y,ca,cap: Double;
begin
  x:=Pi/2;
  y:=x/256;
  for i:=0 to 255 do
  begin
    ca:=Cos(x);
    cap:=Power(ca,Focus);
    x:=(x-y);
    r:=Trunc((Diffuse*ca)+(Specular*cap));
    if r>255 then Result[i]:=255 else Result[i]:=r;
  end;
end;

procedure TBumpForm.MakeLightMap(Size:Integer);
begin
  UseLight24:=False;
  Lightmap24.SetSize(1,1,8);
  
  if Light8Box.Checked then
  begin
    BaseLightmap.SetSize(Size,Size,8);
    BaseLightmap.FillColors(0,255,[tfBlack,tfWhite]);
  end else

  case FormatBox.ItemIndex of
    0: BaseLightmap.SetSizeEx(Size,Size,16,5,5,5);
    1: BaseLightmap.SetSizeEx(Size,Size,16,5,6,5);
    2: BaseLightmap.SetSize(Size,Size,24);
    3: BaseLightmap.SetSize(Size,Size,32);
  end;

  if lightRotatebar.Position<>0 then lightRotatebar.Position:=0;
  lightRotatebox.Checked:=False;
  LightFile:='';

  RenderLightmap(BaseLightmap,Size);

  if not LoadingSet then UpdateLightmap;
end;

procedure TBumpForm.LoadImage(FileName:string; Base,Live:TFastDIB);
var
  ext: string;
  Tmp: TFastDIB;
begin
  Tmp:=TFastDIB.Create;
  if FileExists(FileName)then
  begin
    ext:=LowerCase(ExtractFileExt(FileName));
    if ext='.bmp' then Tmp.LoadFromFile(FileName) else
    if ext='.jpg' then LoadJPGFile(Tmp,FileName,True);
  end else
  begin
    Tmp.SetSize(300,300,24);
    Tmp.Clear(tfWhite);
    Tmp.SetFont('Tahoma',50);
    Tmp.TextOut(20,20,'file not found');
  end;
  Base.SetSize(Tmp.Width,Tmp.Height,24);
  Convert(Tmp,Base);

  case FormatBox.ItemIndex of
    0: Live.SetSizeEx(Tmp.Width,Tmp.Height,16,5,5,5);
    1: Live.SetSizeEx(Tmp.Width,Tmp.Height,16,5,6,5);
    2: Live.SetSize(Tmp.Width,Tmp.Height,24);
    3: Live.SetSize(Tmp.Width,Tmp.Height,32);
  end;
  Convert(Tmp,Live);

  Tmp.Free;
end;

procedure TBumpForm.LoadBumpmap(FileName:string);
var
  ext: string;
  Tmp: TFastDIB;
begin
  Tmp:=TFastDIB.Create;
  if FileExists(FileName)then
  begin
    ext:=LowerCase(ExtractFileExt(FileName));
    if ext='.bmp' then Tmp.LoadFromFile(FileName) else
    if ext='.jpg' then LoadJPGFile(Tmp,FileName,True);
  end else
  begin
    Tmp.SetSize(300,300,24);
    Tmp.Clear(tfWhite);
    Tmp.SetFont('Tahoma',50);
    Tmp.TextOut(20,20,'file not found');
  end;

  Grayscale(Tmp,BaseBumpmap);
  Tmp.Free;

  SetThumbnail(BumpThumb,BaseBumpmap);
  EmbossBumpmap;
end;

procedure TBumpForm.EmbossBumpmap;
var
  Tmp,Tiled: TFastDIB;
  x,y: Integer;
  pn: PNormal;
begin
  if LoadingSet then Exit;

  Tmp:=TFastDIB.Create;
  Tmp.MakeCopy(BaseBumpmap,True);
  ApplyLutB(Tmp,MergeLuts([LightnessLut(bumpLightbar.Position),
                           ContrastLut(bumpContrastbar.Position)]));
  AddNoise(Tmp,bumpNoisebar.Position,True);

  SetThumbnail(BumpThumb,Tmp);

  Tiled:=TFastDIB.Create;
  Tiled.SetSize(Image.Width,Image.AbsHeight,8);
  FastTile(Tmp,Tiled);
  Tmp.Free;

  Bumpmap.SetSize(Tiled.Width,Tiled.AbsHeight,16);
  for y:=1 to Bumpmap.AbsHeight-3 do
  for x:=1 to Bumpmap.Width-3 do
  begin
    pn:=@Bumpmap.Pixels16[y,x];
    pn.x:=Tiled.Pixels8[y+1,x]-Tiled.Pixels8[y+1,x+2];
    pn.y:=Tiled.Pixels8[y,x+1]-Tiled.Pixels8[y+2,x+1];
  end;
  Tiled.Free;
  if Assigned(Viewport)then Viewport.UpdateFrame;
end;

procedure TBumpForm.SetThumbnail(Image:TImage; Bmp:TFastDIB);
var
  Tmp: TFastDIB;
begin
  Tmp:=TFastDIB.Create;
  Tmp.SetSize(105,105,Bmp.Bpp);
  if Tmp.Bpp=8 then
  begin
    Tmp.Colors^:=Bmp.Colors^;
    Tmp.UpdateColors;
  end;

  Bilinear(Bmp,Tmp);
  Tmp.FreeHandle:=False;
  Image.Picture.Bitmap.Handle:=Tmp.Handle;
  Tmp.Free;
  Image.Refresh;
end;

procedure TBumpForm.Button1Click(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    ImageFile:=OpenDialog.FileName;
    LoadImage(ImageFile,Image24,Image);
    SetThumbnail(ImageThumb,Image24);
    if Assigned(Viewport) then
    begin
      Viewport.ClientWidth:=Image.Width;
      Viewport.ClientHeight:=Image.AbsHeight;
    end;
    EmbossBumpmap;
  end;
end;

procedure TBumpForm.FormCreate(Sender: TObject);
var
  Settings: TIniFile;
begin
  if HasJPG then
  begin
    OpenDialog.InitialDir:=Application.EXEName;
    FormatBox.ItemIndex:=1;
    BlendBox.ItemIndex:=0;

    Image24:=TFastDIB.Create;
    Image:=TFastDIB.Create;
    Lightmap24:=TFastDIB.Create;
    BaseLightmap:=TFastDIB.Create;
    Lightmap:=TFastDIB.Create;
    LightCopy:=TFastDIB.Create;
    BaseBumpmap:=TFastDIB.Create;
    Bumpmap:=TFastDIB.Create;
    Frame:=TFastDIB.Create;

    Settings:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'presets.ini');
    Settings.ReadSections(PresetsBox.Items);
    Settings.Free;

    PresetsBox.ItemIndex:=0;
    PresetsBoxChange(Sender);
    Render(Image.Width shr 1,Image.AbsHeight shr 1);
  end else
  begin
    Application.MessageBox(
      'the intel jpeg library is missing..'#13#10+
      'this program requires the file ijl15.dll in order to'#13#10+
      'load it''s JPEG resources. you can download it at'#13#10+
      'http://developer.intel.com/software/products/perflib/ijl'#13#10+
      'http://gfody.com/fastlib/ijl15.zip','IJL15.DLL',MB_ICONERROR or MB_OK);
    Application.Terminate;
  end;
end;

procedure TBumpForm.FormDestroy(Sender: TObject);
begin
  Image24.Free;
  Image.Free;
  Lightmap24.Free;
  BaseLightmap.Free;
  Lightmap.Free;
  LightCopy.Free;
  BaseBumpmap.Free;
  Bumpmap.Free;
  Frame.Free;
end;

procedure TBumpForm.FormatBoxChange(Sender: TObject);
begin
  case FormatBox.ItemIndex of
    0: begin
         Image.SetSizeEx(Image24.Width,Image24.Height,16,5,5,5);
         if UseLight24 and not Light8Box.Checked then
           BaseLightmap.SetSizeEx(Lightmap24.Width,Lightmap24.Height,16,5,5,5);
       end;
    1: begin
         Image.SetSizeEx(Image24.Width,Image24.Height,16,5,6,5);
         if UseLight24 and not Light8Box.Checked then
           BaseLightmap.SetSizeEx(Lightmap24.Width,Lightmap24.Height,16,5,6,5);
       end;
    2: begin
         Image.SetSize(Image24.Width,Image24.Height,24);
         if UseLight24 and not Light8Box.Checked then
           BaseLightmap.SetSize(Lightmap24.Width,Lightmap24.Height,24);
       end;
    3: begin
         Image.SetSize(Image24.Width,Image24.Height,32);
         if UseLight24 and not Light8Box.Checked then
           BaseLightmap.SetSize(Lightmap24.Width,Lightmap24.Height,32);
       end;
  end;
  Convert(Image24,Image);
  if UseLight24 then
  begin
    if not Light8Box.Checked then
      Convert(Lightmap24,BaseLightmap);
  end else MakeLightmap(Lightbar.Position);

  UpdateLightmap;
end;

procedure TBumpForm.Button2Click(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    BumpFile:=OpenDialog.FileName;
    LoadBumpmap(BumpFile);
  end;

end;

procedure TBumpForm.bumpLightbarChange(Sender: TObject);
begin
  EmbossBumpmap;
end;

procedure TBumpForm.Button3Click(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    LightFile:=OpenDialog.FileName;
    LoadImage(LightFile,Lightmap24,BaseLightmap);
    UseLight24:=True;
    Light8Box.Checked:=False;
    UpdateLightmap;
  end;
end;

procedure TBumpForm.LutThumb(Lut:TLut;Image:TImage;Color:TFColor);
var
  i: Integer;
  Tmp: TFastDIB;
begin
  Tmp:=TFastDIB.Create;
  Tmp.SetSize(32,32,8);
  Tmp.FillColors(0,1,[tfBlack,Color]);
  Tmp.ClearB(0);
  for i:=0 to 31 do
    Tmp.Pixels8[Lut[i shl 3]shr 3,i]:=1;
  Tmp.FreeHandle:=False;
  Image.Picture.Bitmap.Handle:=Tmp.Handle;
  Tmp.Free;
  Image.Update;
end;

procedure TBumpForm.LutThumb8(Lut:TLut);
var
  i: Integer;
  Tmp: TFastDIB;
begin
  Tmp:=TFastDIB.Create;
  Tmp.SetSize(98,32,8);
  Tmp.FillColors(0,1,[tfBlack,tfWhite]);
  Tmp.ClearB(0);
  for i:=0 to 97 do
    Tmp.Pixels8[Lut[(i*172960)shr 16]shr 3,i]:=1;
  Tmp.FreeHandle:=False;
  RThumb.Picture.Bitmap.Handle:=Tmp.Handle;
  Tmp.Free;
  RThumb.Update;
end;

procedure TBumpForm.RSpecbarChange(Sender: TObject);
begin
  LightRLut:=SpecularLut(RSpecbar.Position,RDiffusebar.Position,Sqr(RFocusbar.Position*0.01));
  if Light8Box.Checked then
    LutThumb8(LightRLut)
  else
    LutThumb(LightRLut,RThumb,tfRed);

  if not LightAll then UpdateLightmap;
end;

procedure TBumpForm.GSpecbarChange(Sender: TObject);
begin
  LightGLut:=SpecularLut(GSpecbar.Position,GDiffusebar.Position,Sqr(GFocusbar.Position*0.01));
  LutThumb(LightGLut,GThumb,tfLime);
  if not LightAll then UpdateLightmap;
end;

procedure TBumpForm.BSpecbarChange(Sender: TObject);
begin
  LightBLut:=SpecularLut(BSpecbar.Position,BDiffusebar.Position,Sqr(BFocusbar.Position*0.01));
  LutThumb(LightBLut,BThumb,tfBlue);
  if not LightAll then UpdateLightmap;
end;

procedure TBumpForm.ASpecbarChange(Sender: TObject);
begin
  LightAll:=True;
  RSpecbar.Position:=ASpecbar.Position;
  GSpecbar.Position:=ASpecbar.Position;
  BSpecbar.Position:=ASpecbar.Position;
  LightAll:=False;
  UpdateLightmap;
end;

procedure TBumpForm.AFocusbarChange(Sender: TObject);
begin
  LightAll:=True;
  RFocusbar.Position:=AFocusbar.Position;
  GFocusbar.Position:=AFocusbar.Position;
  BFocusbar.Position:=AFocusbar.Position;
  LightAll:=False;
  UpdateLightmap;
end;

procedure TBumpForm.ADiffusebarChange(Sender: TObject);
begin
  LightAll:=True;
  RDiffusebar.Position:=ADiffusebar.Position;
  GDiffusebar.Position:=ADiffusebar.Position;
  BDiffusebar.Position:=ADiffusebar.Position;
  LightAll:=False;
  UpdateLightmap;
end;

procedure TBumpForm.UpdateLightmap;
begin
  if LoadingSet then Exit;

  if(lightRotatebar.Position<>0)and(lightRotatebox.Checked=False)then
  begin
    Lightmap.Clear(tfBlack);
    RotateSize(BaseLightmap,Lightmap,lightRotatebar.Position*0.1);
    Rotate(BaseLightmap,Lightmap,lightRotatebar.Position*0.1,False);
  end else Lightmap.MakeCopy(BaseLightmap,True);

  if HighlightsBox.Checked then
  if Light8Box.Checked then
    ApplyLutB(Lightmap,LightRLut)
  else
    ApplyLut(Lightmap,LightRLut,LightGLut,LightBLut);

  if lightNoisebar.Position<>0 then
    AddNoise(Lightmap,lightNoisebar.Position,lightNoisebox.Checked);

  if lightRotatebox.Checked then
    LightCopy.MakeCopy(Lightmap,True);

  SetThumbnail(LightThumb,Lightmap);
  if Assigned(Viewport) then Viewport.UpdateFrame;
end;

procedure TBumpForm.LightbarChange(Sender: TObject);
begin
  if LoadingSet then Exit;
  
  MakeLightmap(Lightbar.Position);
  Label9.Caption:='generate a lightmap: ['+IntToStr(Lightbar.Position)+']';
end;

procedure TBumpForm.HighlightsBoxClick(Sender: TObject);
begin
  RSpecbar.Enabled:=HighlightsBox.Checked;
  GSpecbar.Enabled:=HighlightsBox.Checked;
  BSpecbar.Enabled:=HighlightsBox.Checked;
  ASpecbar.Enabled:=HighlightsBox.Checked;
  RFocusbar.Enabled:=HighlightsBox.Checked;
  GFocusbar.Enabled:=HighlightsBox.Checked;
  BFocusbar.Enabled:=HighlightsBox.Checked;
  AFocusbar.Enabled:=HighlightsBox.Checked;
  RDiffusebar.Enabled:=HighlightsBox.Checked;
  GDiffusebar.Enabled:=HighlightsBox.Checked;
  BDiffusebar.Enabled:=HighlightsBox.Checked;
  ADiffusebar.Enabled:=HighlightsBox.Checked;
  RThumb.Visible:=HighlightsBox.Checked;
  GThumb.Visible:=(HighlightsBox.Checked)and not Light8Box.Checked;
  BThumb.Visible:=(HighlightsBox.Checked)and not Light8Box.Checked;
  UpdateLightmap;
end;

procedure TBumpForm.lightNoisebarChange(Sender: TObject);
begin
  UpdateLightmap;
end;

procedure TBumpForm.lightNoiseboxClick(Sender: TObject);
begin
  UpdateLightmap;
end;

procedure TBumpForm.lightRotatebarChange(Sender: TObject);
begin
  UpdateLightmap;
end;

procedure TBumpForm.lightRotateboxClick(Sender: TObject);
begin
  Angle:=0.0;
  UpdateLightmap;
  if not lightRotatebox.Checked then LightCopy.SetSize(1,1,8);
end;

procedure TBumpForm.BlendBoxChange(Sender: TObject);
begin
  if Assigned(Viewport) then Viewport.UpdateFrame;
end;

procedure TBumpForm.Light8BoxClick(Sender: TObject);
begin
  GThumb.Visible:=HighlightsBox.Checked and not Light8Box.Checked;
  BThumb.Visible:=HighlightsBox.Checked and not Light8Box.Checked;
  GreenSheet.TabVisible:=not Light8Box.Checked;
  BlueSheet.TabVisible:=not Light8Box.Checked;
  AllSheet.TabVisible:=not Light8Box.Checked;

  if Light8Box.Checked then
  begin
    RThumb.Width:=98;
    RedSheet.Caption:='';
    LutThumb8(LightRLut);
    if UseLight24 then
      Grayscale(Lightmap24,BaseLightmap)
    else
      MakeLightmap(Lightbar.Position);
  end else
  begin
    RThumb.Width:=32;
    RedSheet.Caption:='R';
    LutThumb(LightRLut,RThumb,tfRed);
    if UseLight24 then
    begin
      case FormatBox.ItemIndex of
        0: BaseLightmap.SetSizeEx(Lightmap24.Width,Lightmap24.Height,16,5,5,5);
        1: BaseLightmap.SetSizeEx(Lightmap24.Width,Lightmap24.Height,16,5,6,5);
        2: BaseLightmap.SetSize(Lightmap24.Width,Lightmap24.Height,24);
        3: BaseLightmap.SetSize(Lightmap24.Width,Lightmap24.Height,32);
      end;
      Convert(Lightmap24,BaseLightmap);
    end else MakeLightmap(Lightbar.Position);
  end;

  UpdateLightmap;
end;

procedure TBumpForm.Render(x,y:Integer);
begin
  Frame.MakeCopy(Image,False);

  if(lightRotatebar.Position<>0)and lightRotatebox.Checked then
  begin
    Angle:=Angle+(lightRotatebar.Position*0.1);
    Rotate(LightCopy,Lightmap,Angle,False);
  end;

  BumpImage(Frame,Bumpmap,Lightmap,x,Frame.AbsHeight-y);

  case BlendBox.ItemIndex of
    0: MulBlend(Frame,Image,Frame);
    1: AvgBlend(Frame,Image,Frame);
    2: AddBlend(Frame,Image,Frame);
    3: DifBlend(Frame,Image,Frame);
    4: SubBlend(Frame,Image,Frame);
    5: SubBlend(Frame,Frame,Image);
    6: ; //nada
  end;

  Inc(Frames);
  if FPSBox.Checked then Frame.TextOut(0,0,IntToStr(Fps));

end;

procedure TBumpForm.FpsTimerTimer(Sender: TObject);
begin
  Fps:=Frames;
  Frames:=0;
end;

procedure TBumpForm.Button4Click(Sender: TObject);
var
  Section: string;
  Settings: TIniFile;
begin
  Section:=PresetsBox.Items[PresetsBox.ItemIndex];
  InputQuery('Preset Name','Name for Settings:',Section);
  if Section='' then Exit;

  Settings:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'presets.ini');

  Settings.WriteString(Section,'imagefile',ImageFile);
  Settings.WriteString(Section,'bumpfile',BumpFile);
  Settings.WriteBool(Section,'uselightfile',UseLight24);
  Settings.WriteString(Section,'lightfile',LightFile);
  Settings.WriteInteger(Section,'blendmode',BlendBox.ItemIndex);
  Settings.WriteBool(Section,'autopilot',AutoLightbox.Checked);
  Settings.WriteInteger(Section,'bumplightness',bumpLightbar.Position);
  Settings.WriteInteger(Section,'bumpcontrast',bumpContrastbar.Position);
  Settings.WriteInteger(Section,'bumpnoise',bumpNoisebar.Position);
  Settings.WriteInteger(Section,'lightsize',Lightbar.Position);
  Settings.WriteBool(Section,'light8bit',Light8Box.Checked);
  Settings.WriteBool(Section,'highlights',HighlightsBox.Checked);
  Settings.WriteInteger(Section,'rspecular',RSpecbar.Position);
  Settings.WriteInteger(Section,'rfocus',RFocusbar.Position);
  Settings.WriteInteger(Section,'rdiffuse',RDiffusebar.Position);
  Settings.WriteInteger(Section,'gspecular',GSpecbar.Position);
  Settings.WriteInteger(Section,'gfocus',GFocusbar.Position);
  Settings.WriteInteger(Section,'gdiffuse',GDiffusebar.Position);
  Settings.WriteInteger(Section,'bspecular',BSpecbar.Position);
  Settings.WriteInteger(Section,'bfocus',BFocusbar.Position);
  Settings.WriteInteger(Section,'bdiffuse',BDiffusebar.Position);
  Settings.WriteInteger(Section,'lightnoise',lightNoisebar.Position);
  Settings.WriteBool(Section,'mononoise',lightNoisebox.Checked);
  Settings.WriteInteger(Section,'rotate',lightRotatebar.Position);
  Settings.WriteBool(Section,'animaterotate',lightRotatebox.Checked);
  Settings.WriteInteger(Section,'x',Viewport.mx);
  Settings.WriteInteger(Section,'y',Viewport.my);

  Settings.ReadSections(PresetsBox.Items);

  Settings.Free;
end;

procedure TBumpForm.PresetsBoxChange(Sender: TObject);
var
  Section: string;
  Settings: TIniFile;
begin
  Section:=PresetsBox.Items[PresetsBox.ItemIndex];
  Settings:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'presets.ini');

  LoadingSet:=True;
  ImageFile:=Settings.ReadString(Section,'imagefile',ImageFile);
  LoadImage(ImageFile,Image24,Image);
  SetThumbnail(ImageThumb,Image24);
  if Assigned(Viewport) then
  begin
    Viewport.ClientWidth:=Image.Width;
    Viewport.ClientHeight:=Image.AbsHeight;
  end;

  BumpFile:=Settings.ReadString(Section,'bumpfile',BumpFile);
  LoadBumpmap(BumpFile);

  BlendBox.ItemIndex:=Settings.ReadInteger(Section,'blendmode',0);
  AutoLightbox.Checked:=Settings.ReadBool(Section,'autopilot',AutoLightbox.Checked);
  bumpLightbar.Position:=Settings.ReadInteger(Section,'bumplightness',bumpLightbar.Position);
  bumpContrastbar.Position:=Settings.ReadInteger(Section,'bumpcontrast',bumpContrastbar.Position);
  bumpNoisebar.Position:=Settings.ReadInteger(Section,'bumpnoise',bumpNoisebar.Position);

  HighlightsBox.Checked:=Settings.ReadBool(Section,'highlights',HighlightsBox.Checked);
  RSpecbar.Position:=Settings.ReadInteger(Section,'rspecular',RSpecbar.Position);
  RFocusbar.Position:=Settings.ReadInteger(Section,'rfocus',RFocusbar.Position);
  RDiffusebar.Position:=Settings.ReadInteger(Section,'rdiffuse',RDiffusebar.Position);
  GSpecbar.Position:=Settings.ReadInteger(Section,'gspecular',GSpecbar.Position);
  GFocusbar.Position:=Settings.ReadInteger(Section,'gfocus',GFocusbar.Position);
  GDiffusebar.Position:=Settings.ReadInteger(Section,'gdiffuse',GDiffusebar.Position);
  BSpecbar.Position:=Settings.ReadInteger(Section,'bspecular',BSpecbar.Position);
  BFocusbar.Position:=Settings.ReadInteger(Section,'bfocus',BFocusbar.Position);
  BDiffusebar.Position:=Settings.ReadInteger(Section,'bdiffuse',BDiffusebar.Position);
  lightNoisebar.Position:=Settings.ReadInteger(Section,'lightnoise',lightNoisebar.Position);
  lightNoisebox.Checked:=Settings.ReadBool(Section,'mononoise',lightNoisebox.Checked);
  lightRotatebar.Position:=Settings.ReadInteger(Section,'rotate',lightRotatebar.Position);
  lightRotatebox.Checked:=Settings.ReadBool(Section,'animaterotate',lightRotatebox.Checked);

  LightFile:=Settings.ReadString(Section,'lightfile',LightFile);
  UseLight24:=Settings.ReadBool(Section,'uselightfile',False);
  Light8Box.Checked:=Settings.ReadBool(Section,'light8bit',Light8Box.Checked);
  Lightbar.Position:=Settings.ReadInteger(Section,'lightsize',Lightbar.Position);

  if not UseLight24 then MakeLightmap(Lightbar.Position) else
  begin
    LoadImage(LightFile,Lightmap24,BaseLightmap);
    Light8Box.Checked:=False;
  end;

  LightRLut:=SpecularLut(RSpecbar.Position,RDiffusebar.Position,Sqr(RFocusbar.Position*0.01));
  LightGLut:=SpecularLut(GSpecbar.Position,GDiffusebar.Position,Sqr(GFocusbar.Position*0.01));
  LightBLut:=SpecularLut(BSpecbar.Position,BDiffusebar.Position,Sqr(BFocusbar.Position*0.01));
  if Light8Box.Checked then
    LutThumb8(LightRLut)
  else
    LutThumb(LightRLut,RThumb,tfRed);
  LutThumb(LightGLut,GThumb,tfLime);
  LutThumb(LightBLut,BThumb,tfBlue);

  if Assigned(Viewport) then
  begin
    Viewport.mx:=Settings.ReadInteger(Section,'x',Viewport.mx);
    Viewport.my:=Settings.ReadInteger(Section,'y',Viewport.my);
  end;
  
  LoadingSet:=False;

  Settings.Free;

  EmbossBumpmap;
  UpdateLightmap;
end;

end.
