unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TViewport = class(TForm)
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure UpdateFrame;
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Idle(Sender: TObject; var Done: Boolean);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    mx,my: Integer;
  end;

var
  Viewport: TViewport;
  Held: Boolean = False;
  sx: Integer = 0;
  sy: Integer = 0;

implementation

uses Unit1;

{$R *.DFM}

procedure TViewport.FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
  if ssLeft in Shift then
  begin
    mx:=x;
    my:=y;
    UpdateFrame;
  end;
end;

procedure TViewport.UpdateFrame;
begin
  BumpForm.Render(mx,my);
  BumpForm.Frame.Draw(Canvas.Handle,0,0);
end;


procedure TViewport.FormPaint(Sender: TObject);
begin
  BumpForm.Frame.Draw(Canvas.Handle,0,0);
end;

procedure TViewport.FormCreate(Sender: TObject);
begin
  mx:=256;
  my:=256;
  Application.OnIdle:=Idle;
end;

procedure TViewport.Idle(Sender: TObject; var Done: Boolean);
var
  w,h,d: Integer;
begin
  if Held or not BumpForm.AutoLightbox.Checked then BumpForm.Render(mx,my)else
  begin
    d:=BumpForm.Fps;
    if d=0 then d:=1;

    w:=ClientWidth shr 1;
    h:=ClientHeight shr 1;
    Inc(sx,(w div d)+1);
    Inc(sy,(h div d)+1);

    mx:=Round(Sin(sx/w)*w)+w;
    my:=Round(Cos(sy/h)*h)+h;
    BumpForm.Render(mx,my);
  end;

  BumpForm.Frame.Draw(Canvas.Handle,0,0);
  Done:=False;
end;

procedure TViewport.FormMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  mx:=x;
  my:=y;
  Held:=True;
  BumpForm.AutoLightbox.Checked:=False;
  UpdateFrame;
end;

procedure TViewport.FormMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  Held:=False;
end;

end.
