unit FConvert; // Conversion Routines for TFastDIB
               // 2000 G-Soft http://gfody.com
interface      // Updated: 5/10/2001

uses Windows, FastDIB;

procedure Convert(Src,Dst:TFastDIB);
procedure ConvertTo(Bmp:TFastDIB;Bpp:Integer);
procedure ConvertToEx(Bmp:TFastDIB;Bpp:Integer;Bpr,Bpg,Bpb:Byte);

procedure To1_4(Src,Dst:TFastDIB);
procedure To1_8(Src,Dst:TFastDIB);
procedure To1_16(Src,Dst:TFastDIB);
procedure To1_24(Src,Dst:TFastDIB);
procedure To1_32(Src,Dst:TFastDIB);

procedure To4_1(Src,Dst:TFastDIB);
procedure To4_8(Src,Dst:TFastDIB);
procedure To4_16(Src,Dst:TFastDIB);
procedure To4_24(Src,Dst:TFastDIB);
procedure To4_32(Src,Dst:TFastDIB);

procedure To8_1(Src,Dst:TFastDIB);
procedure To8_4(Src,Dst:TFastDIB);
procedure To8_16(Src,Dst:TFastDIB);
procedure To8_24(Src,Dst:TFastDIB);
procedure To8_32(Src,Dst:TFastDIB);

procedure To16_1(Src,Dst:TFastDIB);
procedure To16_4(Src,Dst:TFastDIB);
procedure To16_8(Src,Dst:TFastDIB);
procedure To16_16(Src,Dst:TFastDIB);
procedure To16_24(Src,Dst:TFastDIB);
procedure To16_32(Src,Dst:TFastDIB);

procedure To24_1(Src,Dst:TFastDIB);
procedure To24_4(Src,Dst:TFastDIB);
procedure To24_8(Src,Dst:TFastDIB);
procedure To24_16(Src,Dst:TFastDIB);
procedure To24_32(Src,Dst:TFastDIB);

procedure To32_1(Src,Dst:TFastDIB);
procedure To32_4(Src,Dst:TFastDIB);
procedure To32_8(Src,Dst:TFastDIB);
procedure To32_16(Src,Dst:TFastDIB);
procedure To32_24(Src,Dst:TFastDIB);
procedure To32_32(Src,Dst:TFastDIB);

type
  TConvertLineProc = procedure(Src,Dst:Pointer;Size:Integer);

implementation

procedure Convert(Src,Dst:TFastDIB);
begin
  if Src.Bpp=Dst.Bpp then Move(Src.Bits^,Dst.Bits^,Dst.Size) else
  case Dst.Bpp of
    1:
    case Src.Bpp of
      4:  To1_4(Src,Dst);
      8:  To1_8(Src,Dst);
      16: To1_16(Src,Dst);
      24: To1_24(Src,Dst);
      32: To1_32(Src,Dst);
    end;
    4:
    case Src.Bpp of
      1:  To4_1(Src,Dst);
      8:  To4_8(Src,Dst);
      16: To4_16(Src,Dst);
      24: To4_24(Src,Dst);
      32: To4_32(Src,Dst);
    end;
    8:
    case Src.Bpp of
      1:  To8_1(Src,Dst);
      4:  To8_4(Src,Dst);
      16: To8_16(Src,Dst);
      24: To8_24(Src,Dst);
      32: To8_32(Src,Dst);
    end;
    16:
    case Src.Bpp of
      1:  To16_1(Src,Dst);
      4:  To16_4(Src,Dst);
      8:  To16_8(Src,Dst);
      16: To16_16(Src,Dst);
      24: To16_24(Src,Dst);
      32: To16_32(Src,Dst);
    end;
    24:
    case Src.Bpp of
      1:  To24_1(Src,Dst);
      4:  To24_4(Src,Dst);
      8:  To24_8(Src,Dst);
      16: To24_16(Src,Dst);
      32: To24_32(Src,Dst);
    end;
    32:
    case Src.Bpp of
      1:  To32_1(Src,Dst);
      4:  To32_4(Src,Dst);
      8:  To32_8(Src,Dst);
      16: To32_16(Src,Dst);
      24: To32_24(Src,Dst);
      32: To32_32(Src,Dst);
    end;
  end;
end;

procedure ConvertTo(Bmp:TFastDIB;Bpp:Integer);
var
  Tmp: TFastDIB;
begin
  if Bmp.Bpp<>Bpp then
  begin
    Tmp:=TFastDIB.Create;
    Tmp.SetSize(Bmp.Width,Bmp.Height,Bpp);
    Convert(Bmp,Tmp);
    Bmp.Assign(Tmp);
  end;
end;

procedure ConvertToEx(Bmp:TFastDIB;Bpp:Integer;Bpr,Bpg,Bpb:Byte);
var
  Tmp: TFastDIB;
begin
  if(Bmp.Bpp<>Bpp)or(Bmp.Bpr<>Bpr)or(Bmp.Bpg<>Bpg)or(Bmp.Bpb<>Bpb)then
  begin
    Tmp:=TFastDIB.Create;
    Tmp.SetSizeEx(Bmp.Width,Bmp.Height,Bpp,Bpr,Bpg,Bpb);
    Convert(Bmp,Tmp);
    Bmp.Assign(Tmp);
  end;
end;

procedure LineTo1_4MMX(Src,Dst:Pointer;Size:Integer);
var
  a,b: Integer; //[ebp-8]
asm
  push esi
  push edi

  mov  a,0
  mov  b,0
  mov  esi,eax
  mov  edi,edx

  db $0F,$76,$D2           /// pcmpeqd mm2,mm2   //11111111111111111111111111111111
  db $0F,$71,$D2,$0C       /// psrlw   mm2,12    //00000000000011110000000000001111
  db $0F,$71,$F2,$08       /// psllw   mm2,8     //00001111000000000000111100000000

  push ecx
  shr  ecx,3
  jz   @skip

  @quads:
    db $0F,$6F,$06           /// movq  mm0,[esi] //00020001000400030006000500080007
  @cleanup:
    db $0F,$6F,$C8           /// movq  mm1,mm0
    db $0F,$71,$D1,$03       /// psrlw mm1,3     //---0002000100040---0006000500080
    db $0F,$EB,$C8           /// por   mm1,mm0   //00020021001400430006006500580087
    db $0F,$6F,$C1           /// movq  mm0,mm1
    db $0F,$71,$F1,$0A       /// psllw mm1,10    //140043----------580087----------
    db $0F,$EB,$C1           /// por   mm0,mm1   //14004321001400435806876500580087
    db $0F,$DB,$C2           /// pand  mm0,mm2   //00004321000000000000876500000000
    db $0F,$6F,$C8           /// movq  mm1,mm0
    db $0F,$72,$F1,$14       /// pslld mm1,20    //876500000000--------------------
    db $0F,$EB,$C1           /// por   mm0,mm1   //87654321000000000000876500000000
    db $0F,$6F,$C8           /// movq  mm1,mm0
    db $0F,$72,$D0,$18       /// psrld mm0,24
    db $0F,$73,$D1,$30       /// psrlq mm1,48
    db $0F,$EB,$C8           /// por   mm1,mm0
    db $0F,$7E,$C8           /// movd  eax,mm1
    mov [edi],ax

    add esi,8
    add edi,2
    dec ecx
  jnz @quads

  cmp esi,0
  je @last

  @skip:
  pop  ecx
  and  ecx,111b
  jz   @exit
  push edi
  mov  edi,ebp
  sub  edi,8  //edi = ebp-8
  mov  edx,ecx
  rep  movsb
  sub  edi,edx
  inc  ecx //ecx = 1
  mov  esi,-8
  db $0F,$6F,$85,$F8,$FF,$FF,$FF/// movq mm0,[ebp-8]
  jmp  @cleanup

  @last:
  pop edi
  mov ecx,edx
  mov [edi],al
  shr ecx,2
  jz  @exit
  mov [edi+1],ah

  @exit:
  db $0F,$77 // emms
  pop edi
  pop esi
end;

procedure LineTo1_4(Src,Dst:Pointer;Size:Integer);
var
  a: Integer; //[ebp-4]
asm
  push esi
  push edi

  mov  a,0
  mov  esi,eax
  mov  edi,edx
  push ecx
  shr  ecx,2
  jz   @skip

  @dwords:
    mov eax,[esi]
  @cleanup:
    mov edx,eax      //00020001000400030006000500080007
    shr edx,3        //---00020001000400030006000500080
    or  edx,eax      //00020021001400430036006500580087
    mov eax,edx
    and edx,$3000300 //00000021000000000000006500000000
    and eax,$0030003 //00000000000000430000000000000087
    shl eax,10       //0000430000000000000087----------
    or  eax,edx      //00004321000000000000876500000000
    mov edx,eax
    shr eax,20       //--------------------000043210000
    or  edx,eax      //--------------------876543210000
    shr edx,4        //------------------------87654321

    mov [edi],dl
    add esi,4
    inc edi
    dec ecx
  jnz @dwords

  cmp esi,0
  je  @exit

  @skip:
  pop  ecx
  and  ecx,11b
  jz   @exit
  push edi
  mov  edi,ebp
  sub  edi,4  //edi = ebp-4
  rep  movsb
  pop  edi
  mov  eax,[ebp-4]
  mov  esi,-4
  inc  ecx
  jmp  @cleanup

  @exit:
  pop edi
  pop esi
end;

procedure To1_4(Src,Dst:TFastDIB);
var
  i: Integer;
  Proc: TConvertLineProc;
begin
  if cfMMX in CPUInfo.Features then Proc:=LineTo1_4MMX else Proc:=LineTo1_4;

  for i:=0 to Src.AbsHeight-1 do
    Proc(Src.Scanlines[i],Dst.Scanlines[i],Src.BWidth-Src.Gap);

  Move(Src.Colors^,Dst.Colors^,2*4);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure LineTo1_8MMX(Src,Dst:Pointer;Size:Integer);
var
  a,b: Integer; // a:b = [ebp-8]
asm
  push esi
  push edi

  mov  a,0
  mov  b,0
  mov  esi,eax
  mov  edi,edx
  push ecx
  shr  ecx,3
  jz   @skip

  @quads:
    db $0F,$6F,$06       /// movq  mm0,[esi] //00000001000000020000000300000004
  @cleanup:
    db $0F,$6F,$C8       /// movq  mm1,mm0   //00000001000000020000000300000004
    db $0F,$71,$F1,$09   /// psllw mm1,9     //0000002---------0000004---------
    db $0F,$EB,$C1       /// por   mm0,mm1   //00000021000000020000004300000004
    db $0F,$6F,$C8       /// movq  mm1,mm0   //00000021000000020000004300000004
    db $0F,$72,$F1,$12   /// pslld mm1,18    //00004300000004------------------
    db $0F,$EB,$C1       /// por   mm0,mm1   //00004321000004020000004300000004
    db $0F,$6F,$C8       /// movq  mm1,mm0   //00004321000004020000004300000004
    db $0F,$73,$D0,$24   /// psrlq mm0,36    //----0000432100000402000000430000
    db $0F,$EB,$C8       /// por   mm1,mm0   //00008765432100000402000000430000
    db $0F,$72,$D1,$14   /// psrld mm1,20    //--------------------000087654321
    db $0F,$7E,$C8       /// movd eax,mm1
    mov [edi],al

    add esi,8
    inc edi
    dec ecx
  jnz @quads

  cmp esi,0
  je @exit

  @skip:
  pop  ecx
  and  ecx,111b
  jz   @exit
  push edi
  mov  edi,ebp
  sub  edi,8  // edi = ebp-8
  rep  movsb
  db $0F,$6F,$85,$F8,$FF,$FF,$FF /// movq mm0,[ebp-8]
  pop  edi
  inc  ecx
  mov  esi,-8
  jmp  @cleanup

  @exit:
  db $0F,$77 // emms
  pop edi
  pop esi
end;

procedure LineTo1_8(Src,Dst:Pointer;Size:Integer);
// a:b = [ebp-8]
// c = [ebp-12]
var
  a,b,c: Integer;
asm
  push esi
  push edi
  push ebx

  mov  a,0
  mov  b,0
  mov  esi,eax
  mov  edi,edx
  push ecx
  shr  ecx,3
  jz   @skip
  add  edx,ecx
  mov  c,edx

  @quads:
    mov eax,[esi]   //00000001000000020000000300000004
    mov ebx,[esi+4] 
  @cleanup:
    mov edx,eax     //00000001000000020000000300000004
    mov ecx,ebx
    shl edx,9       //00000020000000300000004---------
    shl ecx,9
    or  eax,edx     //00000021000000320000004300000004
    or  ebx,ecx
    mov edx,eax     //00000021000000320000004300000004
    mov ecx,ebx
    shr edx,18      //------------------00000021000000
    shr ecx,18
    or  eax,edx     //00000021000000320000004321000004
    or  ebx,ecx
    shl eax,4
    or  eax,ebx
    shr eax,6
    mov [edi],al

    add esi,8
    inc edi
    cmp edi,[ebp-12]
  jne @quads

  cmp esi,0
  je @exit

  @skip:
  pop  ecx
  and  ecx,111b
  jz   @exit
  push edi
  mov  edi,ebp
  sub  edi,8  // edi = ebp-8
  rep  movsb
  pop  ecx
  mov  edi,ecx
  inc  ecx
  mov  [ebp-12],ecx
  mov  eax,[ebp-8]
  mov  ebx,[ebp-4]
  mov  esi,-8
  jmp  @cleanup

  @exit:
  pop ebx
  pop edi
  pop esi
end;

procedure To1_8(Src,Dst:TFastDIB);
var
  i: Integer;
  Proc: TConvertLineProc;
begin
  if cfMMX in CPUInfo.Features then Proc:=LineTo1_8MMX else Proc:=LineTo1_8;

  for i:=0 to Src.AbsHeight-1 do
    Proc(Src.Scanlines[i],Dst.Scanlines[i],Src.BWidth-Src.Gap);

  Move(Src.Colors^,Dst.Colors^,2*4);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure LineTo1_16(Src,Dst:Pointer;Size:Integer);
asm
  push esi
  push edi

  mov esi,eax
  mov edi,edx


  pop edi
  pop esi
end;

function Scan16(Src:Pointer;Value,Size:Integer):Integer;
asm
  push edi
  mov  edi,eax
  mov  eax,edx
  push ecx
  shr  ecx,2
  jz   @skip
  repe scasd
  jnz  @found

  @skip:
  pop  ecx
  and  ecx,11b
  jz   @exit
  mov  cx,[edi]
  cmp  cx,dx
  je   @exit
  mov  eax,ecx
  jmp  @exit

  @found:
  pop  ecx
  mov  eax,[edi-4]
  xor  edx,eax
  cmp  dx,0
  jnz  @exit
  shr  eax,16

  @exit:
  pop  edi
end;

procedure To1_16(Src,Dst:TFastDIB);
var
  i: Integer;
begin


  for i:=0 to Src.AbsHeight-1 do
    LineTo1_16(Src.Scanlines[i],Dst.Scanlines[i],Src.BWidth-Src.Gap);

  if Dst.hDC<>0 then Dst.UpdateColors;
end;

{procedure To1_16(Src,Dst:TFastDIB);
label n16;
var
  Gap,x,y,i: Integer;
  pc: PFColorA;
  pw: PWord;
  pb: PByte;
  fr: Word;
begin
  pw:=Pointer(Src.Bits);
  fr:=pw^;
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      if pw^<>fr then goto n16;
      Inc(pw);
    end;
    pw:=Ptr(Integer(pw)+Src.Gap);
  end;
  n16:
  pc:=Pointer(Dst.Colors);
  pc.b:=(pw^ and Src.BMask+1)shl Src.BShr-1;
  pc.g:=(pw^ shr Src.GShl+1)shl Src.GShr-1;
  pc.r:=(pw^ shr Src.RShl+1)shl Src.RShr-1;
  Inc(pc);
  pc.b:=(fr and Src.BMask+1)shl Src.BShr-1;
  pc.g:=(fr shr Src.GShl+1)shl Src.GShr-1;
  pc.r:=(fr shr Src.RShl+1)shl Src.RShr-1;
  i:=(Src.Width shr 3)-1;
  Gap:=(Src.Width mod 8)shl 1;
  pb:=Pointer(Dst.Bits);
  pw:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      if pw^=fr then pb^:=128 else pb^:=0; Inc(pw);
      if pw^=fr then pb^:=pb^ or 64; Inc(pw);
      if pw^=fr then pb^:=pb^ or 32; Inc(pw);
      if pw^=fr then pb^:=pb^ or 16; Inc(pw);
      if pw^=fr then pb^:=pb^ or 08; Inc(pw);
      if pw^=fr then pb^:=pb^ or 04; Inc(pw);
      if pw^=fr then pb^:=pb^ or 02; Inc(pw);
      if pw^=fr then pb^:=pb^ or 01; Inc(pw);
      Inc(pb);
    end;
    if Gap>0 then if pw^=fr then pb^:=128 else pb^:=0;
    if Gap>1 then if PWord(Integer(pw)+02)^=fr then pb^:=pb^ or 64;
    if Gap>2 then if PWord(Integer(pw)+04)^=fr then pb^:=pb^ or 32;
    if Gap>3 then if PWord(Integer(pw)+06)^=fr then pb^:=pb^ or 16;
    if Gap>4 then if PWord(Integer(pw)+08)^=fr then pb^:=pb^ or 08;
    if Gap>5 then if PWord(Integer(pw)+10)^=fr then pb^:=pb^ or 04;
    if Gap>6 then if PWord(Integer(pw)+12)^=fr then pb^:=pb^ or 02;
    if Gap>7 then if PWord(Integer(pw)+14)^=fr then pb^:=pb^ or 01;
    Inc(pb,Dst.Gap);
    pw:=Ptr(Integer(pw)+Gap+Src.Gap);
  end;
  if Dst.hDC<>0 then Dst.UpdateColors;
end;}

procedure To1_24(Src,Dst:TFastDIB);
label n24;
var
  Gap,x,y,i: Integer;
  pc,pc2: PFColor;
  pca: PFColorA;
  frc: TFColor;
  pb: PByte;
begin
  pc:=Pointer(Src.Bits);
  frc:=pc^;
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      if(pc.b<>frc.b)or(pc.g<>frc.g)or(pc.r<>frc.r)then goto n24;
      Inc(pc);
    end;
    pc:=Ptr(Integer(pc)+Src.Gap);
  end;
  n24:
  pca:=Pointer(Dst.Colors);
  PFColor(pca)^:=frc; Inc(pca);
  PFColor(pca)^:=pc^; frc:=pc^;
  i:=(Src.Width shr 3)-1;
  Gap:=(Src.Width mod 8)*3;
  pb:=Pointer(Dst.Bits);
  pc:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=128 else pb^:=0; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 64; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 32; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 16; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 08; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 04; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 02; Inc(pc);
      if(pc.b=frc.b)and(pc.g=frc.g)and(pc.r=frc.r)then pb^:=pb^ or 01; Inc(pc);
      Inc(pb);
    end;
    if Gap>0 then if(pc.b=frc.b)and(pc.g=frc.b)and(pc.r=frc.r)then pb^:=128 else pb^:=0;
    if Gap>1 then begin pc2:=Ptr(Integer(pc)+03); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 64; end;
    if Gap>2 then begin pc2:=Ptr(Integer(pc)+06); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 32; end;
    if Gap>3 then begin pc2:=Ptr(Integer(pc)+09); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 16; end;
    if Gap>4 then begin pc2:=Ptr(Integer(pc)+12); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 08; end;
    if Gap>5 then begin pc2:=Ptr(Integer(pc)+15); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 04; end;
    if Gap>6 then begin pc2:=Ptr(Integer(pc)+18); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 02; end;
    if Gap>7 then begin pc2:=Ptr(Integer(pc)+21); if(pc2.b=frc.b)and(pc2.g=frc.g)and(pc2.r=frc.r)then pb^:=pb^ or 01; end;
    Inc(pb,Dst.Gap);
    pc:=Ptr(Integer(pc)+Src.Gap+Gap);
  end;
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To1_32(Src,Dst:TFastDIB);
label n32;
var
  Gap,x,y,i: Integer;
  pca: PFColorA;
  pdw: PDWord;
  frd: DWord;
  pb: PByte;
begin
  pdw:=Pointer(Src.Bits);
  frd:=pdw^;
  for y:=0 to Src.AbsHeight-1 do
  for x:=0 to Src.Width-1 do
  begin
    if pdw^<>frd then goto n32;
    Inc(pdw);
  end;
  n32:
  pca:=Pointer(Dst.Colors);
  pca.b:=(frd and Src.BMask+1)shl Src.BShr-1;
  pca.g:=(frd shr Src.GShl+1)shl Src.GShr-1;
  pca.r:=(frd shr Src.RShl+1)shl Src.RShr-1;
  Inc(pca);
  frd:=pdw^;
  pca.b:=(frd and Src.BMask+1)shl Src.BShr-1;
  pca.g:=(frd shr Src.GShl+1)shl Src.GShr-1;
  pca.r:=(frd shr Src.RShl+1)shl Src.RShr-1;
  i:=(Src.Width shr 3)-1;
  Gap:=(Src.Width mod 8)shl 2;
  pb:=Pointer(Dst.Bits);
  pdw:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      if(pdw^=frd)then pb^:=128 else pb^:=0; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 64; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 32; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 16; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 08; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 04; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 02; Inc(pdw);
      if(pdw^=frd)then pb^:=pb^ or 01; Inc(pdw);
      Inc(pb);
    end;
    if Gap>0 then if(pdw^=frd)then pb^:=128 else pb^:=0;
    if Gap>1 then if(PDWord(Integer(pdw)+04)^=frd)then pb^:=pb^ or 64;
    if Gap>2 then if(PDWord(Integer(pdw)+08)^=frd)then pb^:=pb^ or 32;
    if Gap>3 then if(PDWord(Integer(pdw)+12)^=frd)then pb^:=pb^ or 16;
    if Gap>4 then if(PDWord(Integer(pdw)+16)^=frd)then pb^:=pb^ or 08;
    if Gap>5 then if(PDWord(Integer(pdw)+20)^=frd)then pb^:=pb^ or 04;
    if Gap>6 then if(PDWord(Integer(pdw)+24)^=frd)then pb^:=pb^ or 02;
    if Gap>7 then if(PDWord(Integer(pdw)+28)^=frd)then pb^:=pb^ or 01;
    Inc(pb,Dst.Gap);
    pdw:=Ptr(Integer(pdw)+Src.Gap+Gap);
  end;
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure MakeLut4_1(Lut:array of Integer);
asm
  push edi
  mov edi,eax
  xor ecx,ecx

  @bytes:
    mov al,cl
    mov ah,cl
    mov dx,ax
    shl ah,6   //21000000
    shl dh,2   //65432100
    shl al,4   //43210000
    sar ah,6   //22222221
    sar al,6   //44444443
    sar dh,6   //66666665
    sar dl,6   //88888887
    shl eax,16
    mov ax,dx         //22222221444444436666666588888887
    and eax,11111111h //00020001000400030006000500080007
    mov [edi],eax
    add edi,4
    inc ecx
    cmp ecx,256
  jne @bytes

  pop edi
end;

procedure LineTo4_1(Src,Dst:Pointer;Size:Integer;Lut:Pointer);
asm
  push edi
  push esi
  push ebx

  mov esi,eax
  mov edi,edx
  mov ebx,[ebp+8]

  cmp ecx,0
  je @exit

  @bytes:
    movzx eax,Byte([esi])
    mov edx,[ebx+eax*4]
    mov [edi],edx
    add edi,4
    inc esi
    dec ecx
  jnz @bytes

  @exit:
  pop ebx
  pop esi
  pop edi
end;

procedure To4_1(Src,Dst:TFastDIB);
var
  y: Integer;
  Lut: array[Byte]of Integer;
begin
  MakeLut4_1(Lut);

  for y:=0 to Dst.AbsHeight-1 do
    LineTo4_1(Src.Scanlines[y],Dst.Scanlines[y],Src.BWidth-Src.Gap,@Lut);

  Move(Src.Colors^,Dst.Colors^,4*2);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure LineTo4_8MMX(Src,Dst:Pointer;Size:Integer);
// Src  = eax
// Dst  = edx
// Size = ecx
// a:b:c:d = [ebp-16]
var
  d,c,b,a: Integer;
asm
  push edi
  push esi

  mov  a,0
  mov  b,0
  mov  c,0
  mov  d,0

  mov  esi,eax
  mov  edi,edx
  push ecx
  shr  ecx,4
  jz   @skip

  @16bytes:
    db $0F,$6F,$06     /// movq     mm0,[esi] //0102030405060708
    db $0F,$6F,$4E,$08 /// movq     mm1,[esi+8]
  @cleanup:
    db $0F,$6F,$D0     /// movq     mm2,mm0
    db $0F,$6F,$D9     /// movq     mm3,mm1
    db $0F,$71,$F2,$0C /// psllw    mm2,12    //2030405060708090
    db $0F,$71,$F3,$0C /// psllw    mm3,12
    db $0F,$EB,$C2     /// por      mm0,mm2   //2132435465768798
    db $0F,$EB,$CB     /// por      mm1,mm3
    db $0F,$71,$D0,$08 /// psrlw    mm0,8     //0021004300650087
    db $0F,$71,$D1,$08 /// psrlw    mm1,8
    db $0F,$67,$C1     /// packuswb mm0,mm1   //2143658721436587
    db $0F,$7F,$07     /// movq     [edi],mm0
    add esi,16
    add edi,8
    dec ecx
  jnz @16bytes

  cmp esi,0
  je  @last

  @skip:
  pop ecx
  and ecx,1111b
  jz  @exit
  mov edx,edi
  mov edi,ebp
  sub edi,16  //edi = ebp-16
  mov eax,ecx
  rep movsb
  db $0F,$6F,$85,$F0,$FF,$FF,$FF /// movq mm0,[ebp-16]
  db $0F,$6F,$8D,$F8,$FF,$FF,$FF /// movq mm1,[ebp-8]
  mov esi,-16
  sub edi,eax //edi = ebp-16
  inc ecx     //ecx = 1
  jmp @cleanup

  @last:
  mov ecx,eax
  mov edi,edx
  mov esi,ebp
  sub esi,16
  rep movsb

  @exit:
  db $0F,$77 // emms
  pop esi
  pop edi
end;

procedure LineTo4_8(Src,Dst:Pointer;Size:Integer);
// Src  = eax
// Dst  = edx
// Size = ecx
asm
  push ebx
  push edi
  push esi

  mov  esi,eax
  mov  edi,edx
  push ecx
  shr  ecx,2
  jz   @word

  @dwords:
    mov eax,[esi]     //01020304 -> 00002143
    mov ebx,eax
    and eax,$0F000F00 //01000300
    and ebx,$000F000F //00020004
    shl ebx,12
    or  eax,ebx       //21004300
    mov edx,eax
    shr eax,8         //00000043
    shr edx,16        //00002100
    or  eax,edx       //00002143
    mov [edi],ax

    add esi,4
    add edi,2
    dec ecx
  jnz @dwords

  @word:
  pop ecx
  and ecx,11b
  jz  @exit
  cmp ecx,1
  je  @byte

  mov ax,[esi]
  and ax,$0F0F //0102
  mov ebx,eax
  shl ebx,4    //0020
  shr eax,8    //0001
  or  eax,ebx  //0021
  mov [edi],al
  add esi,2
  inc edi
  sub ecx,2
  jz  @exit

  @byte:
  mov al,[esi]
  and al,$0F
  shl eax,4
  mov [edi],al

  @exit:
  pop esi
  pop edi
  pop ebx
end;

procedure To4_8(Src,Dst:TFastDIB);
var
  i: Integer;
  Proc: TConvertLineProc;
begin
  if cfMMX in CPUInfo.Features then Proc:=LineTo4_8MMX else Proc:=LineTo4_8;

  for i:=0 to Dst.AbsHeight-1 do
    Proc(Src.Scanlines[i],Dst.Scanlines[i],Src.BWidth-Src.Gap);

  Move(Src.Colors^,Dst.Colors^,4*16);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To4_16(Src,Dst:TFastDIB);
var
  Bytes: array[Word]of Byte;
  x,y,i: Integer;
  pb,lk: PByte;
  pc: PFColorA;
  pw: PWord;
begin
  FillChar(Bytes,SizeOf(Bytes),$FF);
  pc:=Pointer(Dst.Colors);
  i:=0;

  for y:=0 to Src.AbsHeight-1 do
  begin
    pb:=Dst.Scanlines[y];
    pw:=Src.Scanlines[y];

    for x:=0 to (Src.Width div 2)-1 do
    begin
      lk:=@Bytes[pw^];
      if(lk^=255)and(i<16)then
      begin
        pc.b:=Scale8(pw^ and Src.BMask,Src.Bpb);
        pc.g:=Scale8(pw^ and Src.GMask shr Src.GShl,Src.Bpg);
        pc.r:=Scale8(pw^ and Src.RMask shr Src.RShl,Src.Bpr);
        lk^:=i;
        Inc(i);
        Inc(pc);
      end;
      pb^:=lk^ shl 4;
      Inc(pw);

      lk:=@Bytes[pw^];
      if(lk^=255)and(i<16)then
      begin
        pc.b:=Scale8(pw^ and Src.BMask,Src.Bpb);
        pc.g:=Scale8(pw^ and Src.GMask shr Src.GShl,Src.Bpg);
        pc.r:=Scale8(pw^ and Src.RMask shr Src.RShl,Src.Bpr);
        lk^:=i;
        Inc(i);
        Inc(pc);
      end;
      pb^:=pb^ or lk^;
      Inc(pb);
      Inc(pw);
    end;

    if Src.Gap>0 then
    begin
      lk:=@Bytes[pw^];
      if(lk^=255)and(i<16)then
      begin
        pc.b:=Scale8(pw^ and Src.BMask,Src.Bpb);
        pc.g:=Scale8(pw^ and Src.GMask shr Src.GShl,Src.Bpg);
        pc.r:=Scale8(pw^ and Src.RMask shr Src.RShl,Src.Bpr);
        lk^:=i;
        Inc(i);
        Inc(pc);
      end;
      pb^:=Bytes[pw^]shl 4;
    end;
  end;

  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To4_24(Src,Dst:TFastDIB);
type
  TSpace8 = array[Byte,Byte,Byte]of Byte;
  PSpace8 =^TSpace8;
var
  Space: PSpace8;
  pb,lk: PByte;
  x,y,i: Integer;
  pca: PFColorA;
  pc: PFColor;
begin
  New(Space);
  FillChar(Space^,SizeOf(TSpace8),$FF);
  pca:=Pointer(Dst.Colors);
  i:=0;

  for y:=0 to Src.AbsHeight-1 do
  begin
    pb:=Dst.Scanlines[y];
    pc:=Src.Scanlines[y];

    for x:=0 to (Src.Width div 2)-1 do
    begin
      lk:=@Space[pc.b,pc.g,pc.r];
      if(lk^=255)and(i<16)then
      begin
        pca.c:=pc^;
        Inc(pca);
        lk^:=i;
        Inc(i);
      end;
      pb^:=lk^ shl 4;
      Inc(pc);

      lk:=@Space[pc.b,pc.g,pc.r];
      if(lk^=255)and(i<16)then
      begin
        pca.c:=pc^;
        Inc(pca);
        lk^:=i;
        Inc(i);
      end;
      pb^:=pb^ or lk^;
      Inc(pc);
      Inc(pb);
    end;

    if (Src.Gap and 1)=1 then
    begin
      lk:=@Space[pc.b,pc.g,pc.r];
      if(lk^=255)and(i<16)then
      begin
        pca.c:=pc^;
        Inc(pca);
        lk^:=i;
        Inc(i);
      end;
      pb^:=lk^ shl 4;
    end;
  end;

  Dispose(Space);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To4_32(Src,Dst:TFastDIB);
type
  TSpace8 = array[Byte,Byte,Byte]of Byte;
  PSpace8 =^TSpace8;
var
  Space: PSpace8;
  pb,lk: PByte;
  x,y,i: Integer;
  pc,pca: PFColorA;
begin
  New(Space);
  FillChar(Space^,SizeOf(TSpace8),$FF);
  pca:=Pointer(Dst.Colors);
  i:=0;

  for y:=0 to Src.AbsHeight-1 do
  begin
    pb:=Dst.Scanlines[y];
    pc:=Src.Scanlines[y];

    for x:=0 to (Src.Width div 2)-1 do
    begin
      lk:=@Space[pc.b,pc.g,pc.r];
      if(lk^=255)and(i<16)then
      begin
        pca^:=pc^;
        Inc(pca);
        lk^:=i;
        Inc(i);
      end;
      pb^:=lk^ shl 4;
      Inc(pc);

      lk:=@Space[pc.b,pc.g,pc.r];
      if(lk^=255)and(i<16)then
      begin
        pca^:=pc^;
        Inc(pca);
        lk^:=i;
        Inc(i);
      end;
      pb^:=pb^ or lk^;
      Inc(pc);
      Inc(pb);
    end;

    if (Src.Width and 1)=1 then
    begin
      lk:=@Space[pc.b,pc.g,pc.r];
      if(lk^=255)and(i<16)then
      begin
        pca^:=pc^;
        Inc(pca);
        lk^:=i;
        Inc(i);
      end;
      pb^:=lk^ shl 4;
    end;
  end;

  Dispose(Space);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To8_1(Src,Dst:TFastDIB);
type
  T8Byte  = array[0..7]of Byte;   P8Byte  =^T8Byte;
  T8Bytes = array[Byte]of T8Byte; P8Bytes =^T8Bytes;
var
  Gap,x,y,i: Integer;
  p8bs: P8Bytes;
  p8b: P8Byte;
  pb: PByte;
begin
  New(p8bs);
  pb:=Pointer(p8bs);
  for i:=0 to 255 do
  begin
    pb^:=Byte((i or 127)=255); Inc(pb);
    pb^:=Byte((i or 191)=255); Inc(pb);
    pb^:=Byte((i or 223)=255); Inc(pb);
    pb^:=Byte((i or 239)=255); Inc(pb);
    pb^:=Byte((i or 247)=255); Inc(pb);
    pb^:=Byte((i or 251)=255); Inc(pb);
    pb^:=Byte((i or 253)=255); Inc(pb);
    pb^:=Byte((i or 254)=255); Inc(pb);
  end;
  i:=(Src.Width div 8)-1;
  Gap:=Src.Width mod 8;
  p8b:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p8b^:=p8bs[pb^];
      Inc(pb);
      Inc(p8b);
    end;
    if Gap>0 then Move(p8bs[pb^],p8b^,Gap);
    Inc(pb,Src.Gap);
    p8b:=Ptr(Integer(p8b)+Dst.Gap+Gap);
  end;
  Dispose(p8bs);
  Move(Src.Colors^,Dst.Colors^,8);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To8_4(Src,Dst:TFastDIB);
type
  T2Bytes = array[Byte]of Word;
  P2Bytes =^T2Bytes;
var
  Gap,x,y,i: Integer;
  p2bs: P2Bytes;
  p2b: PWord;
  pb: PByte;
begin
  New(p2bs);
  pb:=Pointer(p2bs);
  for i:=0 to 255 do
  begin
    pb^:=i shr 4;  Inc(pb);
    pb^:=i and 15; Inc(pb);
  end;
  i:=(Src.Width div 2)-1;
  Gap:=Src.Width mod 2;
  p2b:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p2b^:=p2bs[pb^];
      Inc(pb);
      Inc(p2b);
    end;
    if Gap>0 then Move(p2bs[pb^],p2b^,Gap);
    Inc(pb,Src.Gap);
    p2b:=Ptr(Integer(p2b)+Dst.Gap+Gap);
  end;
  Dispose(p2bs);
  Move(Src.Colors^,Dst.Colors^,64);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To8_16(Src,Dst:TFastDIB);
type
  TWords = array[Word]of Word;
  PWords =^TWords;
var
  x,y,i: Integer;
  Words: PWords;
  pw,ph: PWord;
  cc: PFColorA;
  pb: PByte;
begin
  New(Words);
  FillChar(Words^,SizeOf(TWords),255);
  cc:=Pointer(Dst.Colors);
  pb:=Pointer(Dst.Bits);
  pw:=Pointer(Src.Bits);
  i:=0;
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      ph:=@Words[pw^];
      if(ph^=$FFFF)and(i<256)then
      begin
        cc.b:=(pw^ and Src.BMask+1)shl Src.BShr-1;
        cc.g:=(pw^ shr Src.GShl+1)shl Src.GShr-1;
        cc.r:=(pw^ shr Src.RShl+1)shl Src.RShr-1;
        ph^:=i;
        Inc(cc);
        Inc(i);
      end;
      pb^:=Words[pw^];
      Inc(pw);
      Inc(pb);
    end;
    Inc(pb,Dst.Gap);
    pw:=Ptr(Integer(pw)+Src.Gap);
  end;
  Dispose(Words);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To8_24(Src,Dst:TFastDIB);
type
  TSpace1 = array[Byte,Byte,0..31]of Byte;
  PSpace1 =^TSpace1;
  TSpace8 = array[Byte,Byte,Byte]of Byte;
  PSpace8 =^TSpace8;
var
  x,y,i: Integer;
  Space1: PSpace1;
  Space8: PSpace8;
  pb,ph: PByte;
  cc: PFColorA;
  pc: PFColor;
  ch: Byte;
begin
  New(Space1);
  New(Space8);
  FillChar(Space1^,SizeOf(TSpace1),0);
  FillChar(Space8^,SizeOf(TSpace8),0);
  pc:=Pointer(Src.Bits);
  pb:=Pointer(Dst.Bits);
  cc:=Pointer(Dst.Colors);
  i:=0;
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      ph:=@Space1[pc.r,pc.g,pc.b shr 3];
      ch:=(1 shl(pc.b and 7));
      if((ph^ and ch)=0)and(i<256)then
      begin
        Space8[pc.r,pc.g,pc.b]:=i;
        PFColor(cc)^:=pc^;
        Inc(cc);
        Inc(i);
        ph^:=ph^ or ch;
      end;
      pb^:=Space8[pc.r,pc.g,pc.b];
      Inc(pb);
      Inc(pc);
    end;
    Inc(pb,Dst.Gap);
    pc:=Ptr(Integer(pc)+Src.Gap);
  end;
  Dispose(Space1);
  Dispose(Space8);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To8_32(Src,Dst:TFastDIB);
type
  TSpace1 = array[Byte,Byte,0..31]of Byte;
  PSpace1 =^TSpace1;
  TSpace8 = array[Byte,Byte,Byte]of Byte;
  PSpace8 =^TSpace8;
var
  x,y,i: Integer;
  Space1: PSpace1;
  Space8: PSpace8;
  cc,pc: PFColorA;
  pb,ph: PByte;
  ch: Byte;
begin
  New(Space1);
  New(Space8);
  FillChar(Space1^,SizeOf(TSpace1),0);
  FillChar(Space8^,SizeOf(TSpace8),0);
  pc:=Pointer(Src.Bits);
  pb:=Pointer(Dst.Bits);
  cc:=Pointer(Dst.Colors);
  i:=0;
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      ph:=@Space1[pc.r,pc.g,pc.b shr 3];
      ch:=(1 shl(pc.b and 7));
      if((ph^ and ch)=0)and(i<256)then
      begin
        Space8[pc.r,pc.g,pc.b]:=i;
        cc.b:=(pc.i and Src.BMask+1)shl Src.BShr-1;
        cc.g:=(pc.i shr Src.GShl+1)shl Src.GShr-1;
        cc.r:=(pc.i shr Src.RShl+1)shl Src.RShr-1;
        Inc(cc);
        Inc(i);
        ph^:=ph^ or ch;
      end;
      pb^:=Space8[pc.r,pc.g,pc.b];
      Inc(pb);
      Inc(pc);
    end;
    Inc(pb,Dst.Gap);
    pc:=Ptr(Integer(pc)+Src.Gap);
  end;
  Dispose(Space1);
  Dispose(Space8);
  if Dst.hDC<>0 then Dst.UpdateColors;
end;

procedure To16_1(Src,Dst:TFastDIB);
type
  T8Word  = array[0..7]of Word;
  P8Word  =^T8Word;
  T8Words = array[Byte]of T8Word;
  P8Words =^T8Words;
var
  Gap,x,y,i: Integer;
  p8ws: P8Words;
  p8w: P8Word;
  pw1: PWord;
  fr,bk: Word;
  pca: PFColorA;
  pb: PByte;
begin
  New(p8ws);
  pca:=Pointer(Src.Colors);
  bk:=pca.r shr Dst.RShr shl Dst.RShl or
      pca.g shr Dst.GShr shl Dst.GShl or
      pca.b shr Dst.BShr; Inc(pca);
  fr:=pca.r shr Dst.RShr shl Dst.RShl or
      pca.g shr Dst.GShr shl Dst.GShl or
      pca.b shr Dst.BShr;
  pw1:=Pointer(p8ws);
  for i:=0 to 255 do
  begin
    if(i or 127)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 191)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 223)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 239)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 247)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 251)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 253)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
    if(i or 254)=255 then pw1^:=fr else pw1^:=bk; Inc(pw1);
  end;
  i:=(Src.Width shr 3)-1;
  Gap:=(Src.Width mod 8)shl 1;
  p8w:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p8w^:=p8ws[pb^];
      Inc(pb);
      Inc(p8w);
    end;
    if Gap>0 then Move(p8ws[pb^],p8w^,Gap);
    Inc(pb,Src.Gap);
    p8w:=Ptr(Integer(p8w)+Dst.Gap+Gap);
  end;
  Dispose(p8ws);
end;

procedure To16_4(Src,Dst:TFastDIB);
type
  TDWords = array[Byte]of DWord;
  PDWords =^TDWords;
var
  Gap,x,y,i: Integer;
  Words: PLine16;
  pdws: PDWords;
  pca: PFColorA;
  pdw: PDWord;
  pw: PWord;
  pb: PByte;
begin
  GetMem(Words,32);
  pw:=Pointer(Words);
  pca:=Pointer(Src.Colors);
  for i:=0 to 15 do
  begin
    pw^:=pca.r shr Dst.RShr shl Dst.RShl or
         pca.g shr Dst.GShr shl Dst.GShl or
         pca.b shr Dst.BShr;
    Inc(pca);
    Inc(pw);
  end;
  New(pdws);
  pw:=Pointer(pdws);
  for i:=0 to 255 do
  begin
    pw^:=Words[i shr 4];  Inc(pw);
    pw^:=Words[i and 15]; Inc(pw);
  end;
  FreeMem(Words);
  i:=(Src.Width shr 1)-1;
  Gap:=(Src.Width mod 2)shl 1;
  pdw:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      pdw^:=pdws[pb^];
      Inc(pb);
      Inc(pdw);
    end;
    if Gap>0 then Move(pdws[pb^],pdw^,Gap);
    Inc(pb,Src.Gap);
    pdw:=Ptr(Integer(pdw)+Dst.Gap+Gap);
  end;
  Dispose(pdws);
end;

procedure To16_8(Src,Dst:TFastDIB);
var
  x,y,i: Integer;
  Words: PLine16;
  pca: PFColorA;
  pb: PByte;
  pw: PWord;
begin
  pca:=Pointer(Src.Colors);
  GetMem(Words,512);
  pw:=Pointer(Words);
  for i:=0 to 255 do
  begin
    pw^:=pca.r shr Dst.RShr shl Dst.RShl or
         pca.g shr Dst.GShr shl Dst.GShl or
         pca.b shr Dst.BShr;
    Inc(pca);
    Inc(pw);
  end;
  pw:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pw^:=Words[pb^];
      Inc(pw);
      Inc(pb);
    end;
    Inc(pb,Src.Gap);
    pw:=Ptr(Integer(pw)+Dst.Gap);
  end;
  FreeMem(Words);
end;

procedure To16_16(Src,Dst:TFastDIB);
var
  Words: PLine16;
  pw1,pw2: PWord;
  x,y: Integer;
  i: DWord;
begin
  GetMem(Words,131072);
  pw1:=Pointer(Words);
  for i:=0 to 65535 do
  begin
    pw1^:=((i shr Src.RShl+1)shl Src.RShr-1)and $FF shr Dst.RShr shl Dst.RShl or
          ((i shr Src.GShl+1)shl Src.GShr-1)and $FF shr Dst.GShr shl Dst.GShl or
          ((i and Src.BMask+1)shl Src.BShr-1)and $FF shr Dst.BShr;
    Inc(pw1);
  end;
  pw1:=Pointer(Dst.Bits);
  pw2:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pw1^:=Words[pw2^];
      Inc(pw1);
      Inc(pw2);
    end;
    pw1:=Ptr(Integer(pw1)+Dst.Gap);
    pw2:=Ptr(Integer(pw2)+Src.Gap);
  end;
  FreeMem(Words);
end;

procedure To16_24(Src,Dst:TFastDIB);
var
  r16,g16,b16: PLine16;
  x,y: Integer;
  pc: PFColor;
  pw: PWord;
begin
  GetMem(r16,512);
  GetMem(g16,512);
  GetMem(b16,512);
  for x:=0 to 255 do
  begin
    r16[x]:=x shr Dst.RShr shl Dst.RShl;
    g16[x]:=x shr Dst.GShr shl Dst.GShl;
    b16[x]:=x shr Dst.BShr;
  end;
  pw:=Pointer(Dst.Bits);
  pc:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pw^:=b16[pc.b]or g16[pc.g]or r16[pc.r];
      Inc(pw);
      Inc(pc);
    end;
    pw:=Ptr(Integer(pw)+Dst.Gap);
    pc:=Ptr(Integer(pc)+Src.Gap);
  end;
  FreeMem(b16);
  FreeMem(g16);
  FreeMem(r16);
end;

procedure To16_32(Src,Dst:TFastDIB);
var
  r16,g16,b16: PLine16;
  x,y: Integer;
  pc: PDWord;
  pw: PWord;
begin
  GetMem(r16,512);
  GetMem(g16,512);
  GetMem(b16,512);
  for x:=0 to 255 do
  begin
    r16[x]:=x shr Dst.RShr shl Dst.RShl;
    g16[x]:=x shr Dst.GShr shl Dst.GShl;
    b16[x]:=x shr Dst.BShr;
  end;
  pw:=Pointer(Dst.Bits);
  pc:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pw^:=b16[((pc^ and Src.BMask+1)shl Src.BShr-1)and $FF]or
           g16[((pc^ shr Src.GShl+1)shl Src.GShr-1)and $FF]or
           r16[((pc^ shr Src.RShl+1)shl Src.RShr-1)and $FF];
      Inc(pw);
      Inc(pc);
    end;
    pw:=Ptr(Integer(pw)+Dst.Gap);
    pc:=Ptr(Integer(pc)+Src.Gap);
  end;
  FreeMem(b16);
  FreeMem(g16);
  FreeMem(r16);
end;

procedure To24_1(Src,Dst:TFastDIB);
type
  T8Color  = array[0..7]of TFColor;
  P8Color  =^T8Color;
  T8Colors = array[Byte]of T8Color;
  P8Colors =^T8Colors;
var
  Gap,x,y,i: Integer;
  p8cs: P8Colors;
  p8c: P8Color;
  fr,bk: TFColor;
  pc: PFColor;
  pb: PByte;
begin
  bk:=Src.Colors[0].c;
  fr:=Src.Colors[1].c;
  New(p8cs);
  pc:=Pointer(p8cs);
  for i:=0 to 255 do
  begin
    if(i or 127)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 191)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 223)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 239)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 247)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 251)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 253)=255 then pc^:=fr else pc^:=bk; Inc(pc);
    if(i or 254)=255 then pc^:=fr else pc^:=bk; Inc(pc);
  end;
  i:=(Src.Width shr 3)-1;
  Gap:=(Src.Width mod 8)*3;
  p8c:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p8c^:=p8cs[pb^];
      Inc(pb);
      Inc(p8c);
    end;
    if Gap>0 then Move(p8cs[pb^],p8c^,Gap);
    Inc(pb,Src.Gap);
    p8c:=Ptr(Integer(p8c)+Dst.Gap+Gap);
  end;
  Dispose(p8cs);
end;

procedure To24_4(Src,Dst:TFastDIB);
type
  T2Color  = array[0..5]of Byte;
  P2Color  =^T2Color;
  T2Colors = array[Byte]of T2Color;
  P2Colors =^T2Colors;
var
  Gap,x,y,i: Integer;
  p2cs: P2Colors;
  p2c: P2Color;
  pc: PFColor;
  pb: PByte;
begin
  New(p2cs);
  pc:=Pointer(p2cs);
  for i:=0 to 255 do
  begin
    pc^:=Src.Colors[i shr 4].c;  Inc(pc);
    pc^:=Src.Colors[i and 15].c; Inc(pc);
  end;
  i:=(Src.Width shr 1)-1;
  Gap:=(Src.Width mod 2)*3;
  p2c:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p2c^:=p2cs[pb^];
      Inc(pb);
      Inc(p2c);
    end;
    if Gap>0 then Move(p2cs[pb^],p2c^,Gap);
    Inc(pb,Src.Gap);
    p2c:=Ptr(Integer(p2c)+Dst.Gap+Gap);
  end;
  Dispose(p2cs);
end;

procedure To24_8(Src,Dst:TFastDIB);
var
  x,y: Integer;
  pc: PFColor;
  pb: PByte;
begin
  pc:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pc^:=Src.Colors[pb^].c;
      Inc(pc);
      Inc(pb);
    end;
    Inc(pb,Src.Gap);
    pc:=Ptr(Integer(pc)+Dst.Gap);
  end;
end;

procedure To24_16(Src,Dst:TFastDIB);
var
  x,y,i: Integer;
  m24: PLine24;
  pc: PFColor;
  pw: PWord;
begin
  GetMem(m24,196608);
  pc:=Pointer(m24);
  for i:=0 to 65535 do
  begin
    pc.b:=(i and Src.BMask+1)shl Src.BShr-1;
    pc.g:=(i shr Src.GShl+1)shl Src.GShr-1;
    pc.r:=(i shr Src.RShl+1)shl Src.RShr-1;
    Inc(pc);
  end;
  pc:=Pointer(Dst.Bits);
  pw:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pc^:=m24[pw^];
      Inc(pc);
      Inc(pw);
    end;
    pw:=Ptr(Integer(pw)+Src.Gap);
    pc:=Ptr(Integer(pc)+Dst.Gap);
  end;
  FreeMem(m24);
end;

procedure To24_32(Src,Dst:TFastDIB);
var
  x,y: Integer;
  pd: PFColorA;
  pc: PFColor;
begin
  pc:=Pointer(Dst.Bits);
  pd:=Pointer(Src.Bits);
  if(Src.Bpb=8)and(Src.Bpg=8)and(Src.Bpr=8)then
  begin
    for y:=0 to Src.AbsHeight-1 do
    begin
      for x:=0 to Src.Width-1 do
      begin
        pc^:=pd.c;
        Inc(pc);
        Inc(pd);
      end;
      pc:=Ptr(Integer(pc)+Dst.Gap);
      pd:=Ptr(Integer(pd)+Src.Gap);
    end;
  end else
  begin
    for y:=0 to Src.AbsHeight-1 do
    begin
      for x:=0 to Src.Width-1 do
      begin
        pc.b:=(pd.i and Src.BMask+1)shl Src.BShr-1;
        pc.g:=(pd.i shr Src.GShl+1)shl Src.GShr-1;
        pc.r:=(pd.i shr Src.RShl+1)shl Src.RShr-1;
        Inc(pc);
        Inc(pd);
      end;
      pc:=Ptr(Integer(pc)+Dst.Gap);
      pd:=Ptr(Integer(pd)+Src.Gap);
    end;
  end;
end;

procedure To32_1(Src,Dst:TFastDIB);
type
  T8Color  = array[0..7]of Integer;
  P8Color  =^T8Color;
  T8Colors = array[Byte]of T8Color;
  P8Colors =^T8Colors;
const
  Masks: array[0..7]of Byte = (127,191,223,239,247,251,253,254);
var
  Gap,x,y,i: Integer;
  p8cs: P8Colors;
  p8c: P8Color;
  pc: TFColorA;
  pd: PDWord;
  pb: PByte;
begin
  New(p8cs);
  pd:=Pointer(p8cs);
  for i:=0 to 255 do
  for x:=0 to 7 do
  begin
    pc:=Src.Colors[Byte((i or Masks[x])=255)];
    pd^:=pc.r shr Dst.RShr shl Dst.RShl or
         pc.g shr Dst.GShr shl Dst.GShl or
         pc.b shr Dst.BShr;
    Inc(pd);
  end;
  i:=(Src.Width shr 3)-1;
  Gap:=(Src.Width mod 8)shl 2;
  p8c:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p8c^:=p8cs[pb^];
      Inc(pb);
      Inc(p8c);
    end;
    if Gap>0 then Move(p8cs[pb^],p8c^,Gap);
    Inc(pb,Src.Gap);
    p8c:=Ptr(Integer(p8c)+Gap+Dst.Gap);
  end;
  Dispose(p8cs);
end;

procedure To32_4(Src,Dst:TFastDIB);
type
  T2Color  = array[0..1]of Integer;
  P2Color  =^T2Color;
  T2Colors = array[Byte]of T2Color;
  P2Colors =^T2Colors;
var
  Gap,x,y,i: Integer;
  p2cs: P2Colors;
  p2c: P2Color;
  pc: TFColorA;
  pd: PDWord;
  pb: PByte;
begin
  New(p2cs);
  pd:=Pointer(p2cs);
  for i:=0 to 255 do
  begin
    pc:=Src.Colors[i shr 4];
    pd^:=pc.r shr Dst.RShr shl Dst.RShl or
         pc.g shr Dst.GShr shl Dst.GShl or
         pc.b shr Dst.BShr;
    Inc(pd);
    pc:=Src.Colors[i and 15];
    pd^:=pc.r shr Dst.RShr shl Dst.RShl or
         pc.g shr Dst.GShr shl Dst.GShl or
         pc.b shr Dst.BShr;
    Inc(pd);
  end;
  i:=(Src.Width shr 1)-1;
  Gap:=(Src.Width mod 2)shl 2;
  p2c:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to i do
    begin
      p2c^:=p2cs[pb^];
      Inc(pb);
      Inc(p2c);
    end;
    if Gap>0 then Move(p2cs[pb^],p2c^,Gap);
    Inc(pb,Src.Gap);
    p2c:=Ptr(Integer(p2c)+Gap+Dst.Gap);
  end;
  Dispose(p2cs);
end;

procedure To32_8(Src,Dst:TFastDIB);
type
  TDWords = array[Word]of DWord;
  PDWords =^TDWords;
var
  DWords: PDWords;
  x,y: Integer;
  pc: PFColorA;
  pd: PDWord;
  pb: PByte;
begin
  GetMem(DWords,1024);
  pd:=Pointer(DWords);
  pc:=Pointer(Src.Colors);
  for x:=0 to 255 do
  begin
    pd^:=pc.r shr Dst.RShr shl Dst.RShl or
         pc.g shr Dst.GShr shl Dst.GShl or
         pc.b shr Dst.BShr;
    Inc(pd);
    Inc(pc);
  end;
  pd:=Pointer(Dst.Bits);
  pb:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pd^:=DWords[pb^];
      Inc(pd);
      Inc(pb);
    end;
    Inc(pb,Src.Gap);
    pd:=Ptr(Integer(pd)+Dst.Gap);
  end;
  FreeMem(DWords);
end;

procedure To32_16(Src,Dst:TFastDIB);
type
  TDWords = array[Word]of DWord;
  PDWords =^TDWords;
var
  DWords: PDWords;
  x,y,i: DWord;
  pd: PDWord;
  pw: PWord;
begin
  GetMem(DWords,262144);
  pd:=Pointer(DWords);
  pd^:=0;
  Inc(pd);
  for i:=1 to 65535 do
  begin
    pd^:=((i and Src.BMask+1)shl Src.BShr-1)and $FF shr Dst.BShr or
         ((i shr Src.GShl+1)shl Src.GShr-1)and $FF shr Dst.GShr shl Dst.GShl or
         ((i shr Src.RShl+1)shl Src.RShr-1)and $FF shr Dst.RShr shl Dst.RShl;
    Inc(pd);
  end;
  pd:=Pointer(Dst.Bits);
  pw:=Pointer(Src.Bits);
  for y:=0 to Src.AbsHeight-1 do
  begin
    for x:=0 to Src.Width-1 do
    begin
      pd^:=DWords[pw^];
      Inc(pd);
      Inc(pw);
    end;
    pw:=Ptr(Integer(pw)+Src.Gap);
    pd:=Ptr(Integer(pd)+Dst.Gap);
  end;
  FreeMem(DWords);
end;

procedure To32_24(Src,Dst:TFastDIB);
var
  x,y: Integer;
  pfc: PFColor;
  pc: PFColorA;
  pd: PDWord;
begin
  pfc:=Pointer(Src.Bits);
  if(Dst.Bpr=8)and(Dst.Bpg=8)and(Dst.Bpb=8)then
  begin
    pc:=Pointer(Dst.Bits);
    for y:=0 to Src.AbsHeight-1 do
    begin
      for x:=0 to Src.Width-1 do
      begin
        PFColor(pc)^:=pfc^;
        Inc(pc);
        Inc(pfc);
      end;
      pfc:=Ptr(Integer(pfc)+Src.Gap);
      pc:=Ptr(Integer(pc)+Dst.Gap);
    end;
  end else
  begin
    pd:=Pointer(Dst.Bits);
    for y:=0 to Src.AbsHeight-1 do
    begin
      for x:=0 to Src.Width-1 do
      begin
        pd^:=pfc.r shr Dst.RShr shl Dst.RShl or
             pfc.g shr Dst.GShr shl Dst.GShl or
             pfc.b shr Dst.BShr;
        Inc(pd);
        Inc(pfc);
      end;
      pfc:=Ptr(Integer(pfc)+Src.Gap);
      pd:=Ptr(Integer(pd)+Dst.Gap);
    end;
  end;
end;

procedure To32_32(Src,Dst:TFastDIB);
var
  x,y: Integer;
  pd1,pd2: PDWord;
begin
  pd1:=Pointer(Dst.Bits);
  pd2:=Pointer(Src.Bits);
  if(Dst.Bpr=Src.Bpr)and(Dst.Bpg=Src.Bpg)and(Dst.Bpb=Src.Bpb)then
  begin
    for y:=0 to Src.AbsHeight-1 do
      Move(Src.Scanlines[y]^,Dst.Scanlines[y]^,Dst.BWidth-Dst.Gap);
  end else
  begin
    for y:=0 to Src.AbsHeight-1 do
    begin
      for x:=0 to Src.Width-1 do
      begin
        pd1^:=((pd2^ and Src.BMask+1)shl Src.BShr-1)and $FF shr Dst.BShr or
              ((pd2^ shr Src.GShl+1)shl Src.GShr-1)and $FF shr Dst.GShr shl Dst.GShl or
              ((pd2^ shr Src.RShl+1)shl Src.RShr-1)and $FF shr Dst.RShr shl Dst.RShl;
        Inc(pd1);
        Inc(pd2);
      end;
      pd1:=Ptr(Integer(pd1)+Dst.Gap);
      pd2:=Ptr(Integer(pd2)+Src.Gap);
    end;
  end;
end;

end.
